#include <iostream>

#include "rendering/FileTexture.h"
#include "tests/ArrayTests.h"
#include "tests/BitArrayTests.h"
#include "tests/BufferTests.h"
#include "tests/ClockTests.h"
#include "tests/ColorTests.h"
#include "tests/FrustumTests.h"
#include "tests/HashMapTests.h"
#include "tests/HeapArrayTests.h"
#include "tests/ListTests.h"
#include "tests/MatrixStackTests.h"
#include "tests/MatrixTests.h"
#include "tests/ObjectPoolTests.h"
#include "tests/PNGReaderTests.h"
#include "tests/PlaneTests.h"
#include "tests/QuaternionTests.h"
#include "tests/RandomTests.h"
#include "tests/RingBufferTests.h"
#include "tests/SplitStringTests.h"
#include "tests/StackAllocatorTests.h"
#include "tests/StackTests.h"
#include "tests/StringBufferTests.h"
#include "tests/TypedBufferTests.h"
#include "tests/UtilsTests.h"
#include "tests/VectorTests.h"
#include "wrapper/Framebuffer.h"

int main(int argAmount, char** args) {
    if(argAmount < 2) {
        std::cout << "missing path to images\n";
        return 0;
    }
    ArrayTests::test();
    HeapArrayTests::test();
    HashMapTests::test();
    ListTests::test();
    BitArrayTests::test();
    StringBufferTests::test();
    RandomTests::test();
    RingBufferTests::test();
    SplitStringTests::test();
    VectorTests::test();
    MatrixTests::test();
    StackTests::test();
    MatrixStackTests::test();
    PlaneTests::test();
    FrustumTests::test();
    QuaternionTests::test();
    UtilsTests::test();
    ColorTests::test();
    ClockTests::test();
    PNGReaderTests::test(args[1]);
    BufferTests::test();
    StackAllocatorTests::test();
    TypedBufferTests::test();
    ObjectPoolTests::test();
    return 0;
}