#include "tests/TypedBufferTests.h"
#include "tests/Test.h"
#include "utils/TypedBuffer.h"

static void testAdd(Test& test) {
    TypedBuffer<int> buffer(10);
    for(int i = 0; i < 100000; i++) {
        buffer.add(5);
        buffer.add(5L);
        buffer.add(5.0f);
        buffer.add(5.0);
    }
    test.checkEqual(400000, buffer.getLength(), "add increments length");
    test.checkEqual(static_cast<int> ((sizeof (int)) * 400000), buffer.getByteLength(), "add increments byte length");
}

void TypedBufferTests::test() {
    Test test("TypedBuffer");
    testAdd(test);
    test.finalize();
}