#ifndef WINDOW_H
#define WINDOW_H

#include <GL/glew.h>
#include <GLFW/glfw3.h>

#include "wrapper/WindowOptions.h"

class Window final {
    GLFWwindow* window;

public:
    Window(const WindowOptions& options);
    ~Window();

    Window(const Window&) = delete;
    Window& operator=(const Window&) = delete;
    Window(Window&&) = delete;
    Window& operator=(Window&&) = delete;

    bool hasError() const;
    void show();
    bool shouldClose() const;
    void swapBuffers();

    void trapCursor(bool trap);
    Size getSize() const;
    Size getFramebufferSize() const;
    bool isKeyDown(int key) const;
};

#endif